VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2520
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4155
   LinkTopic       =   "Form1"
   ScaleHeight     =   2520
   ScaleWidth      =   4155
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CmdGO 
      Caption         =   "GO"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub CmdGO_Click()
    ' Start Rose
    Dim App As RoseApplication
    Set App = GetObject(, "Rose.Application")
    Dim Model As RoseModel
    Set Model = App.NewModel
    'Create a component
    Dim IsOverridden As Boolean
    Dim CVPackages As RoseSubsystemCollection
    Set CVPackages = Model.GetAllSubsystems
    Dim ComponentView As RoseSubsystem
    Set ComponentView = CVPackages.GetAt(1)
    Dim NewComponent As RoseModule
    Set NewComponent = ComponentView.AddModule("NewComponent")
    NewComponent.AssignedLanguage = "ANSI C++"
    ' Set the root directory
    IsOverridden = NewComponent.OverrideProperty("Cplusplus", _
                                  "RevEngRootDirectory", _
                                  "C:\\MyDirectory")
    ' Create a class
    Dim LVPackages As RoseCategoryCollection
    Set LVPackages = Model.GetAllCategories
    Dim LogicalView As RoseCategory
    Set LogicalView = LVPackages.GetAt(1)
    Dim NewClass As RoseClass
    Set NewClass = LogicalView.AddClass("NewClass")
    ' Assign the class to the component
    NewClass.AddAssignedModule NewComponent
    ' Put the component on a diagram and select it
    Dim Diagram As RoseModuleDiagram
    Set Diagram = ComponentView.AddModuleDiagram("New Diagram")
    Diagram.Activate
    Dim View As RoseComponentView
    Set View = Diagram.AddComponentView(NewComponent)
    View.SetSelected (True)
    ' Get the ANSI C++ addin
    Dim AddinManager As RoseAddInManager
    Set AddinManager = App.AddinManager
    Dim Addins As RoseAddInCollection
    Set Addins = AddinManager.Addins
    Dim ANSIIndex As Integer
    ANSIIndex = Addins.FindFirst("Cplusplus")
    Dim ANSIAddin As RoseAddIn
    Set ANSIAddin = Addins.GetAt(ANSIIndex)
    'ANSIAddin.OnGenerateWithoutDialog
    Dim AA As Object
    Set AA = ANSIAddin.EventHandler
    AA.OnGenerateWithoutDialog App
    AA.OnReverseEngineerWithoutDialog App
End Sub

